using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BunnyMark
{
    class FPS
    {
        DateTime oldTime;
        DateTime newTime;
        DateTime startTime;
        float[] fpsList;
        int currentIndex;
        public String fpsText;
        int historySize = 20;
        int numTicks;
       		
		public FPS() 
		{
            fpsList = new float[historySize];

            for (int i = 0; i < historySize; i++)
            {
                fpsList[i] = 0f;
            }

            startTime = DateTime.Now;
		}
		
		public void update()
        {
            numTicks++;

            oldTime = newTime;
            newTime = DateTime.Now;

            float timeBetweenFrames = (float)(newTime-oldTime).TotalMilliseconds;

            fpsList[currentIndex] = timeBetweenFrames;
            currentIndex++;
            if (currentIndex == historySize)
            {
                currentIndex = 0;
            }

			float total = 0;

            for (int i = 0; i < historySize; i++) 
			{
				total += fpsList[i];
			}

            //float realFps = (float)Math.Round(total / historySize);

            float realFps = 1000 / (total / historySize);

            //correct:
            fpsText = "FPS: " + realFps.ToString();


            //fpsText = "FPS: " + (startTime - oldTime).TotalMilliseconds + " : " + numTicks;//+ fps.ToString();
            //fpsText = "FPS: " + ((numTicks / 30) / ((newTime - startTime).TotalMilliseconds / 1000));//+ fps.ToString();
            //fpsText = "frames:" + numTicks + " seconds:" + ((newTime - startTime).TotalMilliseconds / 1000);//+ fps.ToString();
            //fpsText = "FPS:" + (numTicks / ((newTime - startTime).TotalMilliseconds / 1000));
        }
    }
}
